/*
 * CVS: $Id: mmc.c,v 1.3 2003/03/08 10:44:00 andreas Exp $
 *
 */

#include <io.h>
#include <msp430/usart.h>
#include "mmc.h"

unsigned char spi_read()
{
  SPI_WRITE(0xFF);
  WAIT_RX_COMPLETE();
  return RXBUF0;
}

void mmc_init(void)
{
  int i;

  EN_HIGH();

  for(i = 0; i < 10; i++) {              // 80 cycles
    TXBUF0=DUMMY;
    while ((UTCTL0 & TXEPT) == 0);
  }

  EN_LOW();

  mmc_sendcmd(0);            // wait until cmd0 returns 1
  mmc_wait_response(1);

  do {
    mmc_sendcmd(1);
  } while (mmc_wait_response(0) == 0xFF); // wait until cmd1 returns 0

}

// send command
void mmc_sendcmd(unsigned char command)
{
  int count;

  SPI_WRITE(0x40 + command);

  for(count=0;count<4;count++) {
    SPI_WRITE(0x00);
  }

  if(command == 0) {
    SPI_WRITE(0x95);     // CRC for cmd0
  } else {
    SPI_WRITE(0xFF);     // CRC not used, send 0xFF
  }
}
  

unsigned char mmc_wait_response(unsigned char expect)
{
  unsigned char response;
  int i=8;
  
  do {
    response = SPI_READ();
    i--;
  } while ((response != expect) && (i > 0));

  if (i == 0) {
    return 0xFF; // timeout
  } else {
    return response;
  }
  
}
