/*
 * CVS: $Id: mmc.h,v 1.9 2003/03/08 10:44:00 andreas Exp $
 *
 *
 */

#ifndef MMC_H
#define MMC_H

#define EN_LOW() (P3OUT &= ~0x01)
#define EN_HIGH() (P3OUT |= 0x01)
#define SPI_RX_COMPLETE (IFG2 & URXIFG0)
#define SPI_TX_READY (IFG2 & UTXIFG0)

#define WAIT_RX_COMPLETE() while(!SPI_RX_COMPLETE)
#define WAIT_TX_READY() while(!SPI_TX_READY)

#define DUMMY 0xFF

// SPI macros
#define SPI_WRITE(x) { WAIT_TX_READY(); TXBUF0 = (x); }
#define SPI_READ()   spi_read()

// function prototypes
unsigned char spi_read(void);
void mmc_init(void);
void mmc_sendcmd(unsigned char);
unsigned char mmc_wait_response(unsigned char);

// MMC commands
#define MMC_GO_IDLE_STATE 0
#define MMC_SEND_OP_COND 1
#define MMC_SEND_CSD 9
#define MMC_SEND_CID 10
#define MMC_STOP_TRANSMISSION 12
#define MMC_SEND_STATUS 13
#define MMC_SET_BLOCKLEN 16
#define MMC_READ_SINGLE_BLOCK 17
#define MMC_READ_MULTIPLE_BLOCK 18
#define MMC_WRITE BLOCK 24
#define MMC_WRITE_MULTIPLE_BLOCK 25
#define MMC_PROGRAM_CSD 27
#define MMC_SET_WRITE_PROT 28
#define MMC_CLR_WRITE_PROT 29
#define MMC_SEND_WRITE_PROT 30
#define MMC_TAG_SECTOR_START 32
#define MMC_TAG_SECTOR_END 33
#define MMC_UNTAG_SECTOR 34
#define MMC_TAG_EREASE_GROUP_START 35
#define MMC_TAG_EREASE_GROUP_END 36
#define MMC_UNTAG_EREASE_GROUP 37
#define MMC_EREASE 38
#define MMC_READ_OCR 58
#define MMC_CRC_ON_OFF 59

#endif // MMC_H
